import java.io.*;
import java.lang.*;
import javax.swing.*;
import java.awt.FlowLayout;
import java.awt.event.*;

public class NavigAction extends AbstractAction{
  private NavigFen fenetre;

  public static double epsilon = 0.00001;
  public NavigAction(NavigFen fenetre, String texte){
    super(texte);
    this.fenetre=fenetre;
  }
 
  private static double Gud(int phideg, float phimin, String s){
    double phi=0.0;
    phi=(Math.PI/180)*(phideg+phimin/60);
    if ((s.compareTo("N")!=0) && (s.compareTo("n")!=0)){
      phi=-phi;
    }
    return Math.log(Math.tan(phi/2+Math.PI/4));
  }

  private static double Gud(double phi){
    return Math.log(Math.tan(phi/2+Math.PI/4));
  }

  private static double tcap(int gdeg1, float gmin1, String s1, int phideg1, float phimin1, String s2, int gdeg2, float gmin2, String s3,int phideg2, float phimin2, String s4){
  double g1,g2;
  g1=(Math.PI/180)*(gdeg1+gmin1/60);
  if ((s1.compareTo("E")!=0) && (s1.compareTo("e")!=0)){
      g1=-g1;
    }
  g2=(Math.PI/180)*(gdeg2+gmin2/60);
  if ((s3.compareTo("E")!=0) && (s3.compareTo("e")!=0)){
      g2=-g2;
    }  
  return (g2-g1)/(Gud(phideg2,phimin2,s4)-Gud(phideg1,phimin1,s2));
  }

  private static double tcap(double g1, double phi1, double g2, double phi2){
  
  return (g2-g1)/(Gud(phi2)-Gud(phi1));
  }


  private static double ccap(int gdeg1, float gmin1, String s1, int phideg1, float phimin1, String s2, int gdeg2, float gmin2, String s3,int phideg2, float phimin2, String s4){
  double g1,g2,phi1,phi2,t;
  g1=(Math.PI/180)*(gdeg1+gmin1/60);
  if ((s1.compareTo("E")!=0) && (s1.compareTo("e")!=0)){
      g1=-g1;
    }
  g2=(Math.PI/180)*(gdeg2+gmin2/60);
  if ((s3.compareTo("E")!=0) && (s3.compareTo("e")!=0)){
      g2=-g2;
    }
  phi1=(Math.PI/180)*(phideg1+phimin1/60);
  if ((s2.compareTo("N")!=0) && (s1.compareTo("n")!=0)){
      phi1=-phi1;
    }
  phi2=(Math.PI/180)*(phideg2+phimin2/60);
  if ((s4.compareTo("N")!=0) && (s3.compareTo("n")!=0)){
      phi2=-phi2;
    }
/*           
Ajout pour tenir compte du trajet dans l'autre sens
*/
  if (g2-g1> Math.PI) {
    g1=g1+2*Math.PI;
  }
  else if (g2-g1<-Math.PI) {
    g2=g2+2*Math.PI;
  }
  if (Math.abs(phi2-phi1)<epsilon){
    if (Math.abs(g2-g1)<epsilon){
      return 1000;
    }
    else {
      if (g2>g1){
        return 90;
      }
      else {
        return 270;
      } 
    }
  }
  else {
/*    t=tcap(gdeg1,gmin1,s1,phideg1,phimin1,s2,gdeg2,gmin2,s3,phideg2,phimin2,s4);*/
    t=tcap(g1,phi1,g2,phi2);
    if (g2>g1){
      if (phi2>phi1){
        return (180/Math.PI)*(Math.atan(t));
      }
      else {
        return (180/Math.PI)*(Math.atan(t))+180;
      }
    }
    else {
      if (phi2>phi1){
        return (180/Math.PI)*(Math.atan(t))+360;
      }
      else {
        return (180/Math.PI)*(Math.atan(t))+180; 
      }
    }
  }  
  }

  private static double dist(int gdeg1, float gmin1, String s1, int phideg1, float phimin1, String s2, int gdeg2, float gmin2, String s3,int phideg2, float phimin2, String s4){
  double g1,g2,phi1,phi2,t;
  g1=(Math.PI/180)*(gdeg1+gmin1/60);
  if ((s1.compareTo("E")!=0) && (s1.compareTo("e")!=0)){
      g1=-g1;
    }
  g2=(Math.PI/180)*(gdeg2+gmin2/60);
  if ((s3.compareTo("E")!=0) && (s3.compareTo("e")!=0)){
      g2=-g2;
    }
  phi1=(Math.PI/180)*(phideg1+phimin1/60);
  if ((s2.compareTo("N")!=0) && (s1.compareTo("n")!=0)){
      phi1=-phi1;
    }
  phi2=(Math.PI/180)*(phideg2+phimin2/60);
  if ((s4.compareTo("N")!=0) && (s3.compareTo("n")!=0)){
      phi2=-phi2;
    }
/* Ajout */
    if (g2-g1> Math.PI) {
    g1=g1+2*Math.PI;
  }
  else if (g2-g1<-Math.PI) {
    g2=g2+2*Math.PI;
  }
/* fin Ajout*/
  if (Math.abs(phi2-phi1)<epsilon){
    if (Math.abs(g2-g1)<epsilon){
      return 0.0;
    }
    else {
      return (Math.cos(phi1))*(Math.abs((60*180/Math.PI)*(g2-g1)));
    }  
  }
  else {
    t=ccap(gdeg1,gmin1,s1,phideg1,phimin1,s2,gdeg2,gmin2,s3,phideg2,phimin2,s4);
    return (180*60/Math.PI)*Math.abs((1/Math.cos((Math.PI/180)*t))*(phi2-phi1));
  }
}
  
  private static double distortho(int gdeg1, float gmin1, String s1, int phideg1, float phimin1, String s2, int gdeg2, float gmin2, String s3,int phideg2, float phimin2, String s4){
  double g1,g2,phi1,phi2;
  g1=(Math.PI/180)*(gdeg1+gmin1/60);
  if ((s1.compareTo("E")!=0) && (s1.compareTo("e")!=0)){
      g1=-g1;
    }
  g2=(Math.PI/180)*(gdeg2+gmin2/60);
  if ((s3.compareTo("E")!=0) && (s3.compareTo("e")!=0)){
      g2=-g2;
    }
  phi1=(Math.PI/180)*(phideg1+phimin1/60);
  if ((s2.compareTo("N")!=0) && (s1.compareTo("n")!=0)){
      phi1=-phi1;
    }
  phi2=(Math.PI/180)*(phideg2+phimin2/60);
  if ((s4.compareTo("N")!=0) && (s3.compareTo("n")!=0)){
      phi2=-phi2;
    }
  return (180*60/Math.PI)*Math.acos(Math.sin(phi1)*Math.sin(phi2)+Math.cos(phi1)*Math.cos(phi2)*Math.cos(g2-g1));
  }

  private static double ari(int gdeg1, float gmin1, String s1, int phideg1, float phimin1, String s2, int gdeg2, float gmin2, String s3,int phideg2, float phimin2, String s4){
  double g1,g2,phi1,phi2,d,signe;
  g1=(Math.PI/180)*(gdeg1+gmin1/60);
  if ((s1.compareTo("E")!=0) && (s1.compareTo("e")!=0)){
      g1=-g1;
    }
  g2=(Math.PI/180)*(gdeg2+gmin2/60);
  if ((s3.compareTo("E")!=0) && (s3.compareTo("e")!=0)){
      g2=-g2;
    }
  phi1=(Math.PI/180)*(phideg1+phimin1/60);
  if ((s2.compareTo("N")!=0) && (s1.compareTo("n")!=0)){
      phi1=-phi1;
    }
  phi2=(Math.PI/180)*(phideg2+phimin2/60);
  if ((s4.compareTo("N")!=0) && (s3.compareTo("n")!=0)){
      phi2=-phi2;
    }

  d= Math.acos(Math.sin(phi1)*Math.sin(phi2)+Math.cos(phi1)*Math.cos(phi2)*Math.cos(g2-g1));
/*           
Ajout pour tenir compte du trajet dans l'autre sens
*/
  if (g2-g1> Math.PI) {
    g1=g1+2*Math.PI;
  }
  else if (g2-g1<-Math.PI) {
    g2=g2+2*Math.PI;
  }
  if (Math.abs(g2-g1)<epsilon){
    if (phi1>phi2) {
      return 180;
    }
    else {
      return 0;
    }
  }
  else {
    if (g2-g1>0){
/*      return (180/Math.PI)*Math.acos((Math.sin(phi2)-Math.sin(phi1)*Math.cos(d))/(Math.sin(d)*Math.cos(phi1)));
*/
      return (180/Math.PI)*Math.acos((Math.cos(phi1)*Math.sin(phi2)-Math.sin(phi1)*Math.cos(phi2)*Math.cos(g2-g1))/(Math.sin(d)));
    }
    else {
      return  360- (180/Math.PI)*Math.acos((Math.cos(phi1)*Math.sin(phi2)-Math.sin(phi1)*Math.cos(phi2)*Math.cos(g2-g1))/(Math.sin(d)));

    }
  }
}


private static double latvertex(int gdeg1, float gmin1, String s1, int phideg1, float phimin1, String s2, int gdeg2, float gmin2, String s3,int phideg2, float phimin2, String s4){
  double g1,g2,phi1,phi2,d,g11,g22;
  phi1=(Math.PI/180)*(phideg1+phimin1/60);
  phi2=(Math.PI/180)*(phideg2+phimin2/60);
  g11=(Math.PI/180)*(gdeg1+gmin1/60);
  g1= g11;
  if ((s1.compareTo("E")!=0) && (s1.compareTo("e")!=0)){
      g1=-g1;
      g11=-g11;
    }
/* on prende le symetrique par rapport au centre s'il le faut
*/
  if ((s2.compareTo("N")!=0) && (s1.compareTo("n")!=0)){
      if (g1<0) { 
        g1=g1+Math.PI;
      }
      else {
        g1=g1-Math.PI;
      }    
    }
  g22=(Math.PI/180)*(gdeg2+gmin2/60);
  g2=g22;
  if ((s3.compareTo("E")!=0) && (s3.compareTo("e")!=0)){
      g2=-g2;
      g22=-g22;
    }
/* on prende le symetrique par rapport au centre s'il le faut
*/
  if ((s4.compareTo("N")!=0) && (s3.compareTo("n")!=0)){
      if (g2<0) { 
        g2=g2+Math.PI;
      }
      else {
        g2=g2-Math.PI;
      }   
  }
  if ((phi1<epsilon) && (phi2<epsilon)){
    if (Math.abs((Math.abs(g22-g11) -Math.PI))<epsilon) {
      return -1000;
    }
    else {
      return 0;
    }
  }
  else {
    d= Math.acos(Math.sin(phi1)*Math.sin(phi2)+Math.cos(phi1)*Math.cos(phi2)*Math.cos(g2-g1));
    if (Math.abs(Math.sin(d)) < epsilon) {
       if ((Math.PI/2 -phi1>=epsilon) && (Math.PI/2 -phi2 >= epsilon) )
         return -1000;
       else {
         return -500;
       }
    }
    else {  
     return (180/Math.PI)*Math.acos(Math.abs((Math.cos(phi1)*Math.cos(phi2)*Math.sin(g2-g1))/Math.sin(d)));
    }
  }
  }



private static double longvertex(int gdeg1, float gmin1, String s1, int phideg1, float phimin1, String s2, int gdeg2, float gmin2, String s3,int phideg2, float phimin2, String s4){
  double g1,g2,phi1,phi2,X1,X2,Y1,Y2,XV,YV,delta,GV;
  phi1=(Math.PI/180)*(phideg1+phimin1/60);
  phi2=(Math.PI/180)*(phideg2+phimin2/60);

  g1=(Math.PI/180)*(gdeg1+gmin1/60);
  if ((s1.compareTo("E")!=0) && (s1.compareTo("e")!=0)){
      g1=-g1;
    }
/* on prende le symetrique par rapport au centre s'il le faut
*/
  if ((s2.compareTo("N")!=0) && (s1.compareTo("n")!=0)){
      if (g1<0) { 
        g1=g1+Math.PI;
      }
      else {
        g1=g1-Math.PI;
      }
    }
  g2=(Math.PI/180)*(gdeg2+gmin2/60);
  if ((s3.compareTo("E")!=0) && (s3.compareTo("e")!=0)){
      g2=-g2;
    }
/* on prende le symetrique par rapport au centre s'il le faut
*/
  if ((s4.compareTo("N")!=0) && (s3.compareTo("n")!=0)){
      if (g2<0) { 
        g2=g2+Math.PI;
      }
      else {
        g2=g2-Math.PI;
      } 
    }

  if ((phi1<epsilon) && (phi2<epsilon)){
    return 1000;
  }
  else {
    if (phi1<epsilon){
      X2= Math.cos(phi2)*Math.cos(g2)/Math.sin(phi2);
      Y2= Math.cos(phi2)*Math.sin(g2)/Math.sin(phi2);
      X1=X2+5*Math.cos(g1);
      Y1=Y2+5*Math.sin(g1);
    }
    else {
      if (phi2<epsilon){
        X1= Math.cos(phi1)*Math.cos(g1)/Math.sin(phi1); 
        Y1= Math.cos(phi1)*Math.sin(g1)/Math.sin(phi1);
        X2=X1+5*Math.cos(g2);
        Y2=Y1+5*Math.sin(g2);
      }
      else {
        X1= Math.cos(phi1)*Math.cos(g1)/Math.sin(phi1);
        X2= Math.cos(phi2)*Math.cos(g2)/Math.sin(phi2);
        Y1= Math.cos(phi1)*Math.sin(g1)/Math.sin(phi1);
        Y2= Math.cos(phi2)*Math.sin(g2)/Math.sin(phi2);
      }
    }
  }
  delta= (X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1);
  XV= (X1*Y2-Y1*X2)*(Y2-Y1)/delta;
  YV= -(X1*Y2-Y1*X2)*(X2-X1)/delta;
  if (Math.abs(Y1-Y2)<epsilon) {
    if (Y1 >= 0) {
      return 90;
    }
    else {
      return -90;
    }
  }
  else {
    GV = (180/Math.PI)*Math.atan((X1-X2)/(Y2-Y1));
    if (XV >= 0){
      return GV;
    } 
    else {
      if (GV>=0){
        return (GV-180);
      }
      else {
        return (GV+180);
      }
    }
  }
}



private static void Test(int I1, int I2, int I3, int I4, float f1, float f2,float f3,float f4, String s1, String s2, String s3, String s4)
  throws NavigException{
  boolean OK=true;
  if (I1>179){
    OK=false;
    throw new NavigException(1);  
  }
  else if (I1<0){
    OK=false;
    throw new NavigException(2);
  }
  else if (f1> 59.991){
    OK=false;
    throw new NavigException(3);
  }
  else if (f1 <0){
    OK=false;
    throw new NavigException(4);
  }  
  else if (I2 > 89){
    OK=false;
    throw new NavigException(9);
  }  
   else if (I2 < 0){
    OK=false;
    throw new NavigException(10);
  }  
  else if (f2> 59.991){
    OK=false;
    throw new NavigException(11);
  }
  else if (f2 <0){
    OK=false;
    throw new NavigException(12);
  }  
  else if (I3>179){
    OK=false;
    throw new NavigException(5);  
  }
  else if (I3<0){
    OK=false;
    throw new NavigException(6);
  }
  else if (f3> 59.991){
    OK=false;
    throw new NavigException(7);
  }
  else if (f3 <0){
    OK=false;
    throw new NavigException(8);
  }  
  else if (I4 > 89){
    OK=false;
    throw new NavigException(13);
  }  
   else if (I4 < 0){
    OK=false;
    throw new NavigException(14);
  }  
  else if (f4> 59.991){
    OK=false;
    throw new NavigException(15);
  }
  else if (f4 <0){
    OK=false;
    throw new NavigException(16);
  }
  else if ((s1.compareTo("E")!=0) && (s1.compareTo("e")!=0) && (s1.compareTo("W")!=0) && (s1.compareTo("w")!=0)){
    OK=false;
    throw new NavigException(17);
  }
  else if ((s2.compareTo("N")!=0) && (s2.compareTo("n")!=0) && (s2.compareTo("S")!=0) && (s2.compareTo("s")!=0)){
    OK=false;
    throw new NavigException(19);
  }
  else if ((s3.compareTo("E")!=0) && (s3.compareTo("e")!=0) && (s3.compareTo("W")!=0) && (s3.compareTo("w")!=0)){
    OK=false;
    throw new NavigException(18);
  }
  else if ((s4.compareTo("N")!=0) && (s4.compareTo("n")!=0) && (s4.compareTo("S")!=0) && (s4.compareTo("s")!=0)){
    OK=false;
    throw new NavigException(20);
  }
  }

  public void actionPerformed(ActionEvent ev){
    boolean OK=true;
    int I1=0; int I2=0; int I3=0; int I4=0;
    float f1=0; float f2=0; float f3=0; float f4=0;
    String textnseo1="";
    String textnseo2="";
    String textnseo3="";
    String textnseo4="";
    String affichage = "";
    String result = "";
    String texteentree1 = fenetre.getentree1().getText();
    try {
         I1=Integer.parseInt(texteentree1,10);
        }
        catch(NumberFormatException e){
          result="erreur dans la longitude de A (degres) "+e;
          OK=false;
        }
    if (OK){
    String texteentree2 = fenetre.getentree2().getText();
    try {
         f1=Float.parseFloat(texteentree2);
        }
        catch(NumberFormatException e){
          result="erreur dans la longitude de A (minutes) "+e;
          OK=false;
        }
    if (OK){         
    String texteentree3 = fenetre.getentree3().getText();
    try {
         I2 =Integer.parseInt(texteentree3);
        }
        catch(NumberFormatException e){
          result="erreur dans la latitude de A (degres) "+e;
          OK=false;
        } 
    if (OK){         
    String texteentree4 = fenetre.getentree4().getText();
    try {
         f2 =Float.parseFloat(texteentree4);
        }
        catch(NumberFormatException e){
          result="erreur dans la latitude de A (minutes) "+e;
          OK=false;
        } 
    if (OK){
    String texteentree5 = fenetre.getentree5().getText();
    try {
         I3=Integer.parseInt(texteentree5);
        }
        catch(NumberFormatException e){
          result="erreur dans la longitude de B (degres) "+e;
          OK=false;
        }
    if (OK){         
    String texteentree6 = fenetre.getentree6().getText();
    try {
         f3 =Float.parseFloat(texteentree6);
        }
        catch(NumberFormatException e){
          result="erreur dans la longitude de B (minutes) "+e;
          OK=false;
        }
    if (OK){
    String texteentree7 = fenetre.getentree7().getText();
    try {
         I4=Integer.parseInt(texteentree7);
        }
        catch(NumberFormatException e){
          result="erreur dans la latitude de B (degres) "+e;
          OK=false;
        }
    if (OK){
    String texteentree8 = fenetre.getentree8().getText(); 
    try {
         f4 =Float.parseFloat(texteentree8);
        }
        catch(NumberFormatException e){
          result="erreur dans la latitude de B (minutes) "+e;
          OK=false;
        }
    }}}}}}} 
    
    if (OK){
    textnseo1 = fenetre.getnseo1().getText();
    textnseo2 = fenetre.getnseo2().getText();
    textnseo3 = fenetre.getnseo3().getText();
    textnseo4 = fenetre.getnseo4().getText();
    try {
      Test(I1,I2,I3,I4,f1,f2,f3,f4,textnseo1,textnseo2,textnseo3,textnseo4);
    }
    catch(NavigException e1){
          result=" "+e1;
          OK=false;
    }}
    if (OK){
       double cap = (double) (Math.round(1000*ccap(I1,f1,textnseo1,I2,f2,textnseo2,I3,f3,textnseo3,I4,f4,textnseo4)))/1000;
       String dcap = (Double.valueOf(cap)).toString();
       double distance = (double) (Math.round(1000*dist(I1,f1,textnseo1,I2,f2,textnseo2,I3,f3,textnseo3,I4, f4,textnseo4)))/1000;
       double distanceortho = (double) (Math.round(1000*distortho(I1,f1,textnseo1,I2,f2,textnseo2,I3,f3,textnseo3,I4, f4,textnseo4)))/1000;
       double ario = (double) (Math.round(1000*ari(I1,f1,textnseo1,I2,f2,textnseo2,I3,f3,textnseo3,I4, f4,textnseo4)))/1000;
       double latitudevertex = (double) (Math.round(1000*latvertex(I1,f1,textnseo1,I2,f2,textnseo2,I3,f3,textnseo3,I4, f4,textnseo4)))/1000;
       double longitudevertex=(double) (Math.round(1000*longvertex(I1,f1,textnseo1,I2,f2,textnseo2,I3,f3,textnseo3,I4, f4,textnseo4)))/1000;
       String ddistance = (Double.valueOf(distance)).toString();
       String ddistanceortho = (Double.valueOf(distanceortho)).toString();
       String dario = (Double.valueOf(ario)).toString();
       
       String Slat="";
       String Slong="";
       if (latitudevertex < -900) {
         Slat="points diamétralements opposés";
         Slong ="points diamétralements opposés";
       }
       else {
         if (latitudevertex < -400) {
         Slat="points aux pôles,vertex au pôle";
         Slong ="points aux pôles,vertex au pôle";
         }
       }
       if (longitudevertex >900) {
         Slong=Slong+"  Equateur";
         Slat =Slat + "  Equateur";
       }              
       if (90-latitudevertex < epsilon){
         Slong=Slong+" vertex au pôle";
         Slat=Slat+" vertex au pôle"; 
       }
       if ((latitudevertex > -300) && (longitudevertex < 900) && (90-latitudevertex >= epsilon)){       
           double dlongitudevertex =Double.valueOf(longitudevertex);
           Slong= (Double.valueOf(longitudevertex)).toString() + "°";

/*           double dlatitudevertex =     */
           Slat=(Double.valueOf(latitudevertex)).toString();
/*           Slat=dlatitudevertex.toString();*/
           Slat=Slat.concat("°");
       }
       if (cap > 500) {
         result = "Points confondus " + "   Distance= 0 milles";
       }
       else {
       result = "   Cap= "+ dcap+"°"+"\n   Distance loxo= "+ddistance+" milles  "+"\n   Distance orth= "+ddistanceortho+" milles  ";
       result = result + "\n   Angle de route initial ortho= " + dario+"°";
       result = result + "\n   Lat. vertex Nord = " + Slat;
       result = result + "\n   Long. vertex Nord = " + Slong;
       }
    }

    affichage= "\n"+result;
    fenetre.getresultat().setText(fenetre.getresultat().getText()+"\n\n"+affichage);
  }
}

